/* Matrice doublement ordonnée

Entrée: une matrice M doublement ordonnée (D.O.), x un entier
Sortie: Booléen indiquant si x est dans M

 */
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <stdbool.h>
#include <time.h>


/* Génération et affichage */

// Renvoie une matrice D.O. aléatoire de dimensions n x m
int** random_mat(int n, int m){
	int** res = malloc(n*sizeof(int*));
	for (int i = 0; i < n; ++i)
	{
		res[i] = malloc(m*sizeof(int));
		for (int j = 0; j < m; ++j)
		{
			res[i][j] = 6*(i+j) + (rand()%7 - 3);
		}
	}
	return res;
}

// Affiche le tableau t de n x m cases
void print_mat(int** t, int n, int m){
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			// ce format permet d'afficher sur exactement 5 caractères
			// en mettant des espaces si nécessaire, ce qui permet
			// de bien aligner les colonnes
			printf("%-5d ", t[i][j]); 
		}
		printf("\n");
	}
}

// libère le tableau 2D t de n lignes
void free_mat(int**t, int n){
	for (int i = 0; i < n; ++i)
	{
		free(t[i]);
	}
	free(t);
}



/* SOLUTION */

// Détermine si x est dans la matrice D.O. t de n x m éléments
bool search(int** t, int n, int m, int x){
	return false;
}

int main()
{
	srand(time(NULL));
	int n = 12, m = 10;
	int** t = random_mat(n, m);	
	print_mat(t, n, m);
	printf("Entrez un élément à chercher: ");
	int x;
	scanf("%d", &x);
	printf("%d\n", search(t, n, m, x));

	free_mat(t, n);
	return 0;
}
